#version 330

layout(location = 0) out vec4 finalColor;
uniform sampler2D texture;

in vec2 UV;


float toonify(in float intensity) {
    if (intensity < 0.1) {
        return 0.2;
	}
    else if (intensity < 0.3) {
        return 0.3;
	}
	else if (intensity < 0.5) {
        return 0.5;
	}
    else if (intensity > 0.8) {
        return 0.8;
	}
    else
        return 1.0;
}
 
void main(){
	vec3 textureColor=texture2D(texture, UV).xyz;
	vec4 color=vec4(textureColor, 1);
	float factor = toonify(max(color.x, max(color.y, color.z)));
	finalColor = vec4(factor*color.xyz, 1.0);
}