#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec2 fUVs;
out vec3 Position_worldSpace;
out vec3 Position_cameraSpace;
out vec3 Normal_cameraSpace;
out vec3 EyeDirection_cameraSpace;
out vec3 LightDirection_cameraSpace;
out vec4 ShadowCoord;
out vec3 LightTarget_cameraSpace;

uniform mat4 MVP;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

uniform mat4 normalMatrix;

uniform float lightPosition[3];
uniform float lightTarget[3];
uniform vec3 inverseLightDir;
uniform mat4 depthBiasMVP;

void main()
{
	fUVs=uv;

	gl_Position=MVP*vec4(position, 1);

	ShadowCoord=depthBiasMVP*vec4(position, 1);

	Position_worldSpace=(modelMatrix*vec4(position, 1)).xyz;
	Position_cameraSpace=(viewMatrix*modelMatrix*vec4(position, 1)).xyz;

	//Vertex to camera vector
	vec3 vertexPosition_cameraSpace=(viewMatrix*modelMatrix*vec4(position, 1)).xyz;
	EyeDirection_cameraSpace=vec3(0,0,0) - vertexPosition_cameraSpace;

	//vertex normal vector - in camera space
	//vec3 normalNew=normalize((normalMatrix*vec4(normal, 1)).xyz);
	Normal_cameraSpace=(viewMatrix*modelMatrix*vec4(normal, 0)).xyz;

	//Vertex to Light vector
	vec3 LightPosition_cameraSpace=(viewMatrix*vec4(lightPosition[0], lightPosition[1], lightPosition[2], 1)).xyz;
	LightDirection_cameraSpace=LightPosition_cameraSpace + EyeDirection_cameraSpace;

	//Light Target
	//LightTarget_cameraSpace=(vec4(lightTarget[0], lightTarget[1], lightTarget[2], 1)).xyz;
	//LightTarget_cameraSpace=(vec4(0, 0, lightTarget[2], 1)).xyz;
	LightTarget_cameraSpace=(projectionMatrix*vec4(0, 0, 1, 1)).xyz;
}